=begin
#DocuSign Rooms API - v2

#An API for an integrator to access the features of DocuSign Rooms

OpenAPI spec version: v2
Contact: devcenter@docusign.com
Generated by: https://github.com/swagger-api/swagger-codegen.git

=end

# Common files
require 'docusign_rooms/client/api_client'
require 'docusign_rooms/client/api_error'
require 'docusign_rooms/version'
require 'docusign_rooms/configuration'

# Client Files
require 'docusign_rooms/client/auth/oauth'

# Models
require 'docusign_rooms/models/access_level'
require 'docusign_rooms/models/account_status'
require 'docusign_rooms/models/account_summary'
require 'docusign_rooms/models/activity_type'
require 'docusign_rooms/models/api_error'
require 'docusign_rooms/models/assignable_roles'
require 'docusign_rooms/models/classic_admin_to_invite'
require 'docusign_rooms/models/classic_agent_to_invite'
require 'docusign_rooms/models/classic_manager_permissions'
require 'docusign_rooms/models/classic_manager_to_invite'
require 'docusign_rooms/models/closing_status'
require 'docusign_rooms/models/contact_side'
require 'docusign_rooms/models/country'
require 'docusign_rooms/models/currency'
require 'docusign_rooms/models/custom_data'
require 'docusign_rooms/models/depends_on'
require 'docusign_rooms/models/designated_office'
require 'docusign_rooms/models/designated_region'
require 'docusign_rooms/models/document'
require 'docusign_rooms/models/document_user'
require 'docusign_rooms/models/document_user_for_create'
require 'docusign_rooms/models/e_sign_account_role_settings'
require 'docusign_rooms/models/e_sign_permission_profile'
require 'docusign_rooms/models/e_sign_permission_profile_list'
require 'docusign_rooms/models/external_form_fill_session'
require 'docusign_rooms/models/external_form_fill_session_for_create'
require 'docusign_rooms/models/field'
require 'docusign_rooms/models/field_configuration'
require 'docusign_rooms/models/field_data'
require 'docusign_rooms/models/field_data_for_create'
require 'docusign_rooms/models/field_data_for_update'
require 'docusign_rooms/models/field_set'
require 'docusign_rooms/models/fields_custom_data_filter_type'
require 'docusign_rooms/models/financing_type'
require 'docusign_rooms/models/form_details'
require 'docusign_rooms/models/form_for_add'
require 'docusign_rooms/models/form_group'
require 'docusign_rooms/models/form_group_for_create'
require 'docusign_rooms/models/form_group_for_update'
require 'docusign_rooms/models/form_group_form_to_assign'
require 'docusign_rooms/models/form_group_summary'
require 'docusign_rooms/models/form_group_summary_list'
require 'docusign_rooms/models/form_library_summary'
require 'docusign_rooms/models/form_library_summary_list'
require 'docusign_rooms/models/form_summary'
require 'docusign_rooms/models/form_summary_list'
require 'docusign_rooms/models/global_activity_types'
require 'docusign_rooms/models/global_closing_statuses'
require 'docusign_rooms/models/global_contact_sides'
require 'docusign_rooms/models/global_countries'
require 'docusign_rooms/models/global_currencies'
require 'docusign_rooms/models/global_financing_types'
require 'docusign_rooms/models/global_origins_of_leads'
require 'docusign_rooms/models/global_property_types'
require 'docusign_rooms/models/global_room_contact_types'
require 'docusign_rooms/models/global_seller_decision_types'
require 'docusign_rooms/models/global_special_circumstance_types'
require 'docusign_rooms/models/global_states'
require 'docusign_rooms/models/global_task_date_types'
require 'docusign_rooms/models/global_task_responsibility_types'
require 'docusign_rooms/models/global_task_statuses'
require 'docusign_rooms/models/global_time_zones'
require 'docusign_rooms/models/global_transaction_sides'
require 'docusign_rooms/models/group_form'
require 'docusign_rooms/models/locked_out_details'
require 'docusign_rooms/models/member_sorting_option'
require 'docusign_rooms/models/office'
require 'docusign_rooms/models/office_for_create'
require 'docusign_rooms/models/office_reference_count'
require 'docusign_rooms/models/office_reference_count_list'
require 'docusign_rooms/models/office_summary'
require 'docusign_rooms/models/office_summary_list'
require 'docusign_rooms/models/origin_of_lead'
require 'docusign_rooms/models/permissions'
require 'docusign_rooms/models/product_version'
require 'docusign_rooms/models/property_type'
require 'docusign_rooms/models/region'
require 'docusign_rooms/models/region_reference_count'
require 'docusign_rooms/models/region_reference_count_list'
require 'docusign_rooms/models/region_summary'
require 'docusign_rooms/models/region_summary_list'
require 'docusign_rooms/models/role'
require 'docusign_rooms/models/role_for_create'
require 'docusign_rooms/models/role_for_update'
require 'docusign_rooms/models/role_summary'
require 'docusign_rooms/models/role_summary_list'
require 'docusign_rooms/models/room'
require 'docusign_rooms/models/room_contact_type'
require 'docusign_rooms/models/room_document'
require 'docusign_rooms/models/room_document_list'
require 'docusign_rooms/models/room_document_owner'
require 'docusign_rooms/models/room_folder'
require 'docusign_rooms/models/room_folder_list'
require 'docusign_rooms/models/room_for_create'
require 'docusign_rooms/models/room_invite'
require 'docusign_rooms/models/room_invite_response'
require 'docusign_rooms/models/room_picture'
require 'docusign_rooms/models/room_status'
require 'docusign_rooms/models/room_summary'
require 'docusign_rooms/models/room_summary_list'
require 'docusign_rooms/models/room_template'
require 'docusign_rooms/models/room_templates_summary_list'
require 'docusign_rooms/models/room_user'
require 'docusign_rooms/models/room_user_for_update'
require 'docusign_rooms/models/room_user_removal_detail'
require 'docusign_rooms/models/room_user_sorting_option'
require 'docusign_rooms/models/room_user_summary'
require 'docusign_rooms/models/room_users_result'
require 'docusign_rooms/models/select_list_field_option'
require 'docusign_rooms/models/seller_decision_type'
require 'docusign_rooms/models/special_circumstance_type'
require 'docusign_rooms/models/state'
require 'docusign_rooms/models/task_date_type'
require 'docusign_rooms/models/task_list'
require 'docusign_rooms/models/task_list_for_create'
require 'docusign_rooms/models/task_list_summary'
require 'docusign_rooms/models/task_list_summary_list'
require 'docusign_rooms/models/task_list_template'
require 'docusign_rooms/models/task_list_template_list'
require 'docusign_rooms/models/task_responsibility_type'
require 'docusign_rooms/models/task_status'
require 'docusign_rooms/models/task_summary'
require 'docusign_rooms/models/time_zone'
require 'docusign_rooms/models/transaction_side'
require 'docusign_rooms/models/user'
require 'docusign_rooms/models/user_for_update'
require 'docusign_rooms/models/user_summary'
require 'docusign_rooms/models/user_summary_list'
require 'docusign_rooms/models/user_to_invite'

# APIs
require 'docusign_rooms/api/accounts_api'
require 'docusign_rooms/api/activity_types_api'
require 'docusign_rooms/api/closing_statuses_api'
require 'docusign_rooms/api/contact_sides_api'
require 'docusign_rooms/api/countries_api'
require 'docusign_rooms/api/currencies_api'
require 'docusign_rooms/api/documents_api'
require 'docusign_rooms/api/e_sign_permission_profiles_api'
require 'docusign_rooms/api/external_form_fill_sessions_api'
require 'docusign_rooms/api/fields_api'
require 'docusign_rooms/api/financing_types_api'
require 'docusign_rooms/api/form_details_api'
require 'docusign_rooms/api/form_groups_api'
require 'docusign_rooms/api/form_libraries_api'
require 'docusign_rooms/api/offices_api'
require 'docusign_rooms/api/origins_of_leads_api'
require 'docusign_rooms/api/property_types_api'
require 'docusign_rooms/api/regions_api'
require 'docusign_rooms/api/roles_api'
require 'docusign_rooms/api/room_contact_types_api'
require 'docusign_rooms/api/room_folders_api'
require 'docusign_rooms/api/room_templates_api'
require 'docusign_rooms/api/rooms_api'
require 'docusign_rooms/api/seller_decision_types_api'
require 'docusign_rooms/api/special_circumstance_types_api'
require 'docusign_rooms/api/states_api'
require 'docusign_rooms/api/task_date_types_api'
require 'docusign_rooms/api/task_list_templates_api'
require 'docusign_rooms/api/task_lists_api'
require 'docusign_rooms/api/task_responsibility_types_api'
require 'docusign_rooms/api/task_statuses_api'
require 'docusign_rooms/api/time_zones_api'
require 'docusign_rooms/api/transaction_sides_api'
require 'docusign_rooms/api/users_api'

module DocuSign_Rooms
  class << self
    # Customize default settings for the SDK using block.
    #   DocuSign_Rooms.configure do |config|
    #     config.username = "xxx"
    #     config.password = "xxx"
    #   end
    # If no block given, return the default Configuration object.
    def configure
      if block_given?
        yield(Configuration.default)
      else
        Configuration.default
      end
    end
  end
end