=begin
#DocuSign Rooms API - v2

#An API for an integrator to access the features of DocuSign Rooms

OpenAPI spec version: v2
Contact: devcenter@docusign.com
Generated by: https://github.com/swagger-api/swagger-codegen.git

=end

require 'date'

module DocuSign_Rooms
  class RoomSummary
    attr_accessor :room_id

    attr_accessor :name

    attr_accessor :office_id

    attr_accessor :created_date

    attr_accessor :submitted_for_review_date

    attr_accessor :closed_date

    attr_accessor :rejected_date

    attr_accessor :created_by_user_id

    attr_accessor :rejected_by_user_id

    attr_accessor :closed_status_id

    attr_accessor :field_data_last_updated_date

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'room_id' => :'roomId',
        :'name' => :'name',
        :'office_id' => :'officeId',
        :'created_date' => :'createdDate',
        :'submitted_for_review_date' => :'submittedForReviewDate',
        :'closed_date' => :'closedDate',
        :'rejected_date' => :'rejectedDate',
        :'created_by_user_id' => :'createdByUserId',
        :'rejected_by_user_id' => :'rejectedByUserId',
        :'closed_status_id' => :'closedStatusId',
        :'field_data_last_updated_date' => :'fieldDataLastUpdatedDate'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'room_id' => :'Integer',
        :'name' => :'String',
        :'office_id' => :'Integer',
        :'created_date' => :'DateTime',
        :'submitted_for_review_date' => :'DateTime',
        :'closed_date' => :'DateTime',
        :'rejected_date' => :'DateTime',
        :'created_by_user_id' => :'Integer',
        :'rejected_by_user_id' => :'Integer',
        :'closed_status_id' => :'String',
        :'field_data_last_updated_date' => :'DateTime'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'roomId')
        self.room_id = attributes[:'roomId']
      end

      if attributes.has_key?(:'name')
        self.name = attributes[:'name']
      end

      if attributes.has_key?(:'officeId')
        self.office_id = attributes[:'officeId']
      end

      if attributes.has_key?(:'createdDate')
        self.created_date = attributes[:'createdDate']
      end

      if attributes.has_key?(:'submittedForReviewDate')
        self.submitted_for_review_date = attributes[:'submittedForReviewDate']
      end

      if attributes.has_key?(:'closedDate')
        self.closed_date = attributes[:'closedDate']
      end

      if attributes.has_key?(:'rejectedDate')
        self.rejected_date = attributes[:'rejectedDate']
      end

      if attributes.has_key?(:'createdByUserId')
        self.created_by_user_id = attributes[:'createdByUserId']
      end

      if attributes.has_key?(:'rejectedByUserId')
        self.rejected_by_user_id = attributes[:'rejectedByUserId']
      end

      if attributes.has_key?(:'closedStatusId')
        self.closed_status_id = attributes[:'closedStatusId']
      end

      if attributes.has_key?(:'fieldDataLastUpdatedDate')
        self.field_data_last_updated_date = attributes[:'fieldDataLastUpdatedDate']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          room_id == o.room_id &&
          name == o.name &&
          office_id == o.office_id &&
          created_date == o.created_date &&
          submitted_for_review_date == o.submitted_for_review_date &&
          closed_date == o.closed_date &&
          rejected_date == o.rejected_date &&
          created_by_user_id == o.created_by_user_id &&
          rejected_by_user_id == o.rejected_by_user_id &&
          closed_status_id == o.closed_status_id &&
          field_data_last_updated_date == o.field_data_last_updated_date
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [room_id, name, office_id, created_date, submitted_for_review_date, closed_date, rejected_date, created_by_user_id, rejected_by_user_id, closed_status_id, field_data_last_updated_date].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = DocuSign_Rooms.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
