=begin
#DocuSign Rooms API - v2

#An API for an integrator to access the features of DocuSign Rooms

OpenAPI spec version: v2
Contact: devcenter@docusign.com
Generated by: https://github.com/swagger-api/swagger-codegen.git

=end

require 'date'

module DocuSign_Rooms
  class TaskSummary
    attr_accessor :task_id

    attr_accessor :name

    attr_accessor :requires_approval

    attr_accessor :due_date_type_id

    attr_accessor :due_date_offset

    attr_accessor :fixed_due_date

    attr_accessor :owner_user_id

    attr_accessor :completion_date

    attr_accessor :approval_date

    attr_accessor :rejected_date

    attr_accessor :created_date

    attr_accessor :is_document_task

    attr_accessor :requires_review

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'task_id' => :'taskId',
        :'name' => :'name',
        :'requires_approval' => :'requiresApproval',
        :'due_date_type_id' => :'dueDateTypeId',
        :'due_date_offset' => :'dueDateOffset',
        :'fixed_due_date' => :'fixedDueDate',
        :'owner_user_id' => :'ownerUserId',
        :'completion_date' => :'completionDate',
        :'approval_date' => :'approvalDate',
        :'rejected_date' => :'rejectedDate',
        :'created_date' => :'createdDate',
        :'is_document_task' => :'isDocumentTask',
        :'requires_review' => :'requiresReview'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'task_id' => :'Integer',
        :'name' => :'String',
        :'requires_approval' => :'BOOLEAN',
        :'due_date_type_id' => :'String',
        :'due_date_offset' => :'Integer',
        :'fixed_due_date' => :'DateTime',
        :'owner_user_id' => :'Integer',
        :'completion_date' => :'DateTime',
        :'approval_date' => :'DateTime',
        :'rejected_date' => :'DateTime',
        :'created_date' => :'DateTime',
        :'is_document_task' => :'BOOLEAN',
        :'requires_review' => :'BOOLEAN'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'taskId')
        self.task_id = attributes[:'taskId']
      end

      if attributes.has_key?(:'name')
        self.name = attributes[:'name']
      end

      if attributes.has_key?(:'requiresApproval')
        self.requires_approval = attributes[:'requiresApproval']
      end

      if attributes.has_key?(:'dueDateTypeId')
        self.due_date_type_id = attributes[:'dueDateTypeId']
      end

      if attributes.has_key?(:'dueDateOffset')
        self.due_date_offset = attributes[:'dueDateOffset']
      end

      if attributes.has_key?(:'fixedDueDate')
        self.fixed_due_date = attributes[:'fixedDueDate']
      end

      if attributes.has_key?(:'ownerUserId')
        self.owner_user_id = attributes[:'ownerUserId']
      end

      if attributes.has_key?(:'completionDate')
        self.completion_date = attributes[:'completionDate']
      end

      if attributes.has_key?(:'approvalDate')
        self.approval_date = attributes[:'approvalDate']
      end

      if attributes.has_key?(:'rejectedDate')
        self.rejected_date = attributes[:'rejectedDate']
      end

      if attributes.has_key?(:'createdDate')
        self.created_date = attributes[:'createdDate']
      end

      if attributes.has_key?(:'isDocumentTask')
        self.is_document_task = attributes[:'isDocumentTask']
      end

      if attributes.has_key?(:'requiresReview')
        self.requires_review = attributes[:'requiresReview']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          task_id == o.task_id &&
          name == o.name &&
          requires_approval == o.requires_approval &&
          due_date_type_id == o.due_date_type_id &&
          due_date_offset == o.due_date_offset &&
          fixed_due_date == o.fixed_due_date &&
          owner_user_id == o.owner_user_id &&
          completion_date == o.completion_date &&
          approval_date == o.approval_date &&
          rejected_date == o.rejected_date &&
          created_date == o.created_date &&
          is_document_task == o.is_document_task &&
          requires_review == o.requires_review
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [task_id, name, requires_approval, due_date_type_id, due_date_offset, fixed_due_date, owner_user_id, completion_date, approval_date, rejected_date, created_date, is_document_task, requires_review].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = DocuSign_Rooms.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
